package main

import (
	"github.com/aws/aws-sdk-go/aws"
	"github.com/aws/aws-sdk-go/aws/awsutil"
	"github.com/aws/aws-sdk-go/aws/credentials"
	"github.com/aws/aws-sdk-go/service/s3"
	"github.com/aws/aws-sdk-go/aws/session"
	"fmt"
	"os"
	"bytes"
	"net/http"
	"log"
	"github.com/aws/aws-sdk-go/service/s3/s3manager"
)

// This is a test for exploring Go->s3->ceph
func main() {
	// Alex's ceph in the lab
	aws_access_key_id := "WHF0J757LOLM09WMNIJT"
	aws_secret_access_key := "HxlldU3yBbHXc3jPc4GAWZrHQp1LPLJtsK9oFzOB"
	bucket := "load-test"
	host := "s4.rakops.com"
	fileName := "test.jpg"

	// Aoi's vagrant->docker ceph
	//aws_access_key_id := "TESTACCESS"
	//aws_secret_access_key := "TESTSECRET"
	//bucket := "kobo"
	//host := "s3.rakops.com"
	//fileName := "test.jpg"

	token := ""
	creds := credentials.NewStaticCredentials(aws_access_key_id, aws_secret_access_key, token)
	_, err := creds.Get()
	if err != nil {
		fmt.Printf("bad credentials: %s", err)
	}
	cfg := aws.NewConfig().WithRegion("us-east-1"). // FIXME: this is a buglet
		WithEndpoint(host).
		WithDisableSSL(true).
		WithLogLevel(3).
		WithCredentials(creds)
	fmt.Printf("cfg=%v\n", cfg)
	sess, err := session.NewSession() // There is a session.Must() for convenience
	if err != nil {
		fmt.Printf("bad session=%v\n", err)
	}
	fmt.Printf("sess=%v\n", sess)
	svc := s3.New(sess, cfg)
	fmt.Printf("svc=%v\n", svc)

	testCase := 5
	switch testCase {
	case 1:

		/// FIXME uploading with an uploader, failed talking to lab and to docker
		// 2017/04/12 14:56:57 Unable to upload "test.jpg" to "load-test", MissingRegion: could not find region configuration
		file, err := os.Open(fileName)
		if err != nil {
			log.Fatalf("Unable to open file %q, %v", err)
		}
		defer file.Close()

		uploader := s3manager.NewUploader(sess)
		_, err = uploader.Upload(&s3manager.UploadInput{
			Bucket: aws.String(bucket),
			Key:    aws.String(fileName),
			Body:   file,
		})
		fmt.Printf("uploader=%v\n", uploader)
		if err != nil {
			// Print the error and exit.
			log.Printf("Unable to upload %q to %q, %v", fileName, bucket, err)
		}

		return

	case 2:

		// FIXME create bucket, fails by timing out
		bucket = "fraggle"

		// Wait until bucket is created before finishing
		fmt.Printf("Waiting for bucket %q to be created...\n", bucket)
		err = svc.WaitUntilBucketExists(&s3.HeadBucketInput{
			Bucket: aws.String(bucket),
		})
		if err != nil {
			fmt.Printf("Error occurred while waiting for bucket to be created, %v", err)
			return
		}
		fmt.Printf("Bucket %q successfully created\n", bucket)

		return

	case 3:
		// list buckets, works in lab
		// says failed to list buckets, NoSuchBucket with docker
		result, err := svc.ListBuckets(nil)
		if err != nil {
			fmt.Printf("failed to list buckets, %v\n", err)
		}
		for i, b := range result.Buckets {
			//fmt.Printf("* %s created on %s\n",
			//	aws.StringValue(b.Name), aws.TimeValue(b.CreationDate))
			fmt.Printf("bucket %d = %v\n", i, b)
		}

		return

	case 4:
		// list objects
		// bucket = "kbimages-test" // fails one way:
		// caused by: Get http://kbimages-test.s4.rakops.com/: dial tcp: lookup kbimages-test.s4.rakops.com on 172.19.1.10:53: no such host
		bucket = "load-test" // silently fails to find test_file in lab
		// failed to list objects NoSuchBucket on docker
		i := 0
		err = svc.ListObjectsPages(&s3.ListObjectsInput{
			Bucket: &bucket,
		}, func(p *s3.ListObjectsOutput, last bool) (shouldContinue bool) {
			fmt.Println("Page,", i)
			i++

			for _, obj := range p.Contents {
				fmt.Println("Object:", *obj.Key)
			}
			return true
		})
		if err != nil {
			fmt.Println("failed to list objects", err)
			return
		}

		return
	case 5:
		//FIXME upload file fails in lab
		// on docker, bad response, NoSuchBucket
		file, err := os.Open("test.jpg")
		if err != nil {
			fmt.Printf("err opening file: %s", err)
		}
		defer file.Close()
		fileInfo, _ := file.Stat()
		size := fileInfo.Size()
		buffer := make([]byte, size) // read file content to buffer

		file.Read(buffer)
		fileBytes := bytes.NewReader(buffer)
		fileType := http.DetectContentType(buffer)
		params := &s3.PutObjectInput{
			Bucket:        aws.String(bucket),
			Key:           aws.String("test.jpg"),
			Body:          fileBytes,
			ContentLength: aws.Int64(size),
			ContentType:   aws.String(fileType),
		}
		resp, err := svc.PutObject(params)
		if err != nil {
			fmt.Printf("bad response: %s", err)
		}
		fmt.Printf("response %s", awsutil.StringValue(resp))
	}
}
